{
   uhookscripts, common functionality for hookscripts

   Started On:    17.02.2011.
   Last Update:   01.03.2011.
   
   Thanks to Benjamin Rosseaux.
}

{$MODE OBJFPC}{$H+}
UNIT uhookscripts;

INTERFACE

   USES windows;

function GetCurrentDir(): string;
function Run(const FileName, Parameter: string; WindowState: word): boolean;
   
IMPLEMENTATION

CONST
   PATH_LEN = 32*1024;

VAR
   Buffer:array[0..PATH_LEN-1] of char;

function GetCurrentDir(): string;
begin
   setstring(result, Buffer, GetCurrentDirectory(sizeof(Buffer), Buffer));
   if length(result)>0 then begin
      if result[length(result)] <> '\' then begin
         result := result+'\';
      end;
   end;
end;

function Run(const FileName, Parameter: string; WindowState: word): boolean;
var 
   SUInfo:TStartupInfo;
   ProcInfo:TProcessInformation;
   CommandLine:string;

begin
   if length(FileName)>0 then begin
      CommandLine := '"'+FileName+'" '+Parameter;
   end else begin
      CommandLine := '"cmd" /C '+Parameter;
   end;

   FILLCHAR(SUInfo,sizeof(SUInfo),#0);
   FILLCHAR(ProcInfo,sizeof(ProcInfo),#0);

   with SUInfo do begin
      CB:=sizeof(SUInfo);
      dwFlags:=STARTF_USESHOWWINDOW;
      wShowWindow:=WindowState;
   end;
   
   result:=CreateProcess(nil,pchar(CommandLine),nil,nil,false,NORMAL_PRIORITY_CLASS,nil,pchar(GetCurrentDir),SUInfo,ProcInfo);
   if result then begin
      WaitForSingleObject(ProcInfo.hProcess,INFINITE);
   end;
end;

END.